#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QFileDialog>
#include <QMessageBox>
#include "empfkt.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    connect(ui->actionLoad,SIGNAL(triggered()),this,SLOT(openfile()));
    connect(this,&MainWindow::addfkt,ui->zeichnung,&ZeichnungsWindow::addfkt);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::openfile()
{
   QFileDialog fd(this,"Funktionsdatei auswählen");
   fd.setFileMode(QFileDialog::ExistingFiles);
   fd.setDirectory(QDir::homePath());
   fd.setViewMode(QFileDialog::Detail);
   if(fd.exec())
   {
       filenames = fd.selectedFiles();
       auto info = tr("Auswahl %1\n").arg(filenames.join("\n"));
       QMessageBox::information(this,"Ihre Auswahl",info, QMessageBox::Ok);
       for(QString f: filenames)
       {
           std::string fname = f.toStdString();
           EmpFkt *ef = new EmpFkt();
           read(*ef,fname);

           emit addfkt(ef);
       }
   }
}
