#include "zeichnungswindow.h"
#include <QPainter>

ZeichnungsWindow::ZeichnungsWindow(QWidget *parent): QWidget(parent)
{
   xmin=-10.0;
   ymin=-10.0;
   xmax=10.0;
   ymax=10.0;
}

QSize ZeichnungsWindow::minimumSizeHint() const
{
    return QSize(100,100);
}

QSize ZeichnungsWindow::sizeHint() const
{
    return QSize(400,400);
}

// hier wird gezeichnet
void ZeichnungsWindow::paintEvent(QPaintEvent */*event*/)
{
    QPainter painter(this);
 #if 0 // experimente
    painter.drawText(QRectF(0,0, width(), height()),Qt::AlignCenter, QStringLiteral("Hallo Rudolf"));
    painter.drawLine(0,0,width(),height());
    painter.drawText(0,20,QStringLiteral("Hallo Regina"));

    painter.setPen(QPen(Qt::blue, 1, Qt::DashLine));
    painter.drawRect(1,1,100,200);

    qreal dx = (xmax-xmin)/width();
    qreal dy = (ymax-ymin)/height();
    QTransform scale = QTransform::fromScale(dx,dy);
 #endif
    /* Koordinatensystem */
    painter.drawLine(transx(xmin),transy(0.0),transx(xmax),transy(0));
    painter.drawLine(transx(0.0),transy(ymin),transx(0.0),transy(ymax));

    for(EmpFkt *ef : fktlist_)
    {
        drawfkt(&painter,ef);
    }
}

/* Transformation selber gemacht */
int ZeichnungsWindow::transx(qreal x)
{
   return (x-xmin)*width()/(xmax-xmin);
}

int ZeichnungsWindow::transy(qreal y)
{
    return height()-(y-ymin)*height()/(ymax-ymin);
}

void ZeichnungsWindow::addfkt(EmpFkt *f)
{
   fktlist_.push_back(f);
   update();
}

void ZeichnungsWindow::drawfkt(QPainter *painter,EmpFkt *f)
{
    int i=0;
    int wl;int hl;
    int w; int h;
    for(Tuple t : *f)
    {
        w=transx(t.x);h=transy(t.y);
        if(i>0)
        {
          painter->drawLine(wl,hl,w,h);
        }
        wl=w;hl=h;
        i++;
    }
}
